#include<bits\stdc++.h>


using namespace std;


#define ll long long
#define ld long double
#define pii pair<int, int>
#define all(x) (x).begin(), (x).end()
#define SYNC ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);


/*
ulaz
ogranicenja
kast
ineks
overflow
obrni okreni  i sve moze
*/

char s[200005];

int main()
{

    SYNC
    int n, k;
    cin >> n >> k;

    for(int i = 1; i <= n; i ++)cin >> s[i];

    vector<vector<int>> vec(k + 1, vector<int>(k + 1, 0));



    for(int q = 1; q <= n; q ++)
    {
        int res = q + 1;

        for(int i = 0; i < k; i ++)
            vec[i][s[q] - 'a']++;

        for(int i = 0; i < k; i ++)
        {
            for(int j = 0; j < k; j ++)
            {
                if(i == j)
                    res = min(res, vec[i][j] + 1);
                else
                    res = min(res, vec[i][i] + vec[i][j] + 1);
            }
        }
        cout << res << " ";
    }



    return 0;
}